#!/usr/bin/env python
# this is <readcroposp.py>
# ----------------------------------------------------------------------------
# 
# Copyright (c) 2020 by Thomas Forbriger (KIT, GPI, BFO) 
# 
# read a croposp output table
#
# Written in 2020 by Thomas Forbriger
#
# ----
# This program source code is licensed under a CC0 license.
# 
# To the extent possible under law, the author(s) have waived all copyright
# and related or neighboring rights to this source code. You can copy, modify,
# distribute and compile the code, even for commercial purposes, all without
# asking permission. 
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# 
# For the complete text of the license, please visit
# https://creativecommons.org/publicdomain/zero/1.0/
# ----
#
# REVISIONS and CHANGES 
#    08/12/2020   V1.0   Thomas Forbriger
# 
# ============================================================================
#
import re
import numpy as np
#
def readcroposp(filename, verbose=False):
    """
    Read the table produced by program croposp

    parameters:
        :type filename:     string
        :param filename:    name of croposp table file
        :type verbose:      bool, optional
        :param verbose:     report file name and labels to terminal

    returns:
        :rtype:     dictionary
        :return:    columns read from file
                    the keys in the dictionary are the labels generated by
                    croposp for the respective column
                    the frequency column is provided with the key "frequency"
    """

    if verbose:
        print('read file %s' % filename)

# read trace labels
    labellines=list(filter((lambda x: re.match('^# #',x)), 
      open(filename).readlines()))

# read trace data
    data=np.loadtxt(filename, unpack=False)
    retval=dict()

    for i in range(1,len(data[0,:])):
      label=re.sub('^# #\d+: ', '', labellines[i-1].strip())
      if verbose:
          print('  extract column for %s' % label)
      retval[label]=data[:,i] 

    retval["frequency"]=data[:,0]

    return retval

# ----- END OF readcroposp.py ----- 
